/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.button;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.TerraFirmaCraft;
import net.dries007.tfc.network.PacketKnappingUpdate;

@SideOnly(Side.CLIENT)
public class GuiButtonKnapping extends GuiButton
{
    private final ResourceLocation texture;

    public GuiButtonKnapping(int id, int x, int y, int width, int height, ResourceLocation texture)
    {
        super(id, x, y, width, height, "");
        this.texture = texture;
    }

    public void onClick()
    {
        if (this.field_146124_l)
        {
            this.field_146125_m = false;
            TerraFirmaCraft.getNetwork().sendToServer(new PacketKnappingUpdate(field_146127_k));
        }
    }

    @Override
    public void func_191745_a(@Nonnull Minecraft mc, int mouseX, int mouseY, float partialTicks)
    {
        if (this.field_146125_m)
        {
            GlStateManager.func_179131_c(1, 1, 1, 1);
            mc.func_110434_K().func_110577_a(texture);

            field_146123_n = mouseX >= this.field_146128_h && mouseY >= this.field_146129_i && mouseX < this.field_146128_h + this.field_146120_f && mouseY < this.field_146129_i + this.field_146121_g;

            func_146110_a(field_146128_h, field_146129_i, 0, 0, 16, 16, 16, 16);
            func_146119_b(mc, mouseX, mouseY);
        }
    }
}
