/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.gui;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fluids.capability.CapabilityFluidHandler;
import net.minecraftforge.fluids.capability.IFluidHandler;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.api.capability.IMoldHandler;
import net.dries007.tfc.api.types.Metal;
import net.dries007.tfc.api.util.TFCConstants;
import net.dries007.tfc.util.Helpers;

@SideOnly(Side.CLIENT)
public class GuiLiquidTransfer extends GuiContainerTFC
{
    private static final ResourceLocation BG_TEXTURE = new ResourceLocation(TFCConstants.MOD_ID, "textures/gui/single_inventory.png");
    private final int slotIdx;

    public GuiLiquidTransfer(Container container, EntityPlayer player, String translationKey, boolean mainhand)
    {
        super(container, player.field_71071_by, BG_TEXTURE, translationKey);

        if (mainhand)
            slotIdx = playerInv.field_70461_c;
        else
            slotIdx = 40;
    }

    @Override
    protected void func_146979_b(int mouseX, int mouseY)
    {
        ItemStack stack = playerInv.func_70301_a(slotIdx);
        IFluidHandler cap = stack.getCapability(CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY, null);
        if (cap instanceof IMoldHandler)
        {
            Metal metal = ((IMoldHandler) cap).getMetal();
            if (metal != null)
            {
                String metalName = I18n.func_135052_a(Helpers.getTypeName(metal));
                String amountName = I18n.func_135052_a("tfc.tooltip.units", ((IMoldHandler) cap).getAmount());
                field_146289_q.func_78276_b(metalName, field_146999_f / 2 - field_146289_q.func_78256_a(metalName) / 2, 14, 0x404040);
                field_146289_q.func_78276_b(amountName, field_146999_f / 2 - field_146289_q.func_78256_a(amountName) / 2, 23, 0x404040);
            }
        }
        field_146289_q.func_78276_b(playerInv.func_145748_c_().func_150260_c(), 8, field_147000_g - 94, 0x404040);
    }

}
