/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.container;

import javax.annotation.Nonnull;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

import net.dries007.tfc.objects.inventory.SlotTEInput;
import net.dries007.tfc.objects.te.TEFirePit;

public class ContainerFirePit extends ContainerTE<TEFirePit>
{
    public ContainerFirePit(InventoryPlayer playerInv, TEFirePit te)
    {
        super(playerInv, te);
    }

    @Nonnull
    @Override
    public ItemStack func_82846_b(EntityPlayer player, int index)
    {
        // Slot that was clicked
        Slot slot = field_75151_b.get(index);
        if (slot == null || !slot.func_75216_d())
            return ItemStack.field_190927_a;

        ItemStack stack = slot.func_75211_c();
        ItemStack stackCopy = stack.func_77946_l();

        // Transfer out of the container
        int containerSlots = field_75151_b.size() - player.field_71071_by.field_70462_a.size();
        if (index < containerSlots)
        {
            if (!this.func_75135_a(stack, containerSlots, field_75151_b.size(), true))
            {
                return ItemStack.field_190927_a;
            }
            tile.setAndUpdateSlots(index);
        }
        // Transfer into the container
        else
        {
            // Merge into fuel slot -> item slot
            if (!this.func_75135_a(stack, TEFirePit.SLOT_FUEL_INPUT, TEFirePit.SLOT_ITEM_INPUT + 1, false))
            {
                return ItemStack.field_190927_a;
            }
        }

        if (stack.func_190916_E() == 0)
        {
            slot.func_75215_d(ItemStack.field_190927_a);
        }
        else
        {
            slot.func_75218_e();
        }
        if (stack.func_190916_E() == stackCopy.func_190916_E())
        {
            return ItemStack.field_190927_a;
        }
        slot.func_190901_a(player, stack);
        return stackCopy;
    }

    @Override
    protected void addContainerSlots()
    {
        IItemHandler inventory = tile.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
        if (inventory != null)
        {
            // fuel slots
            for (int i = 0; i < 4; i++)
                func_75146_a(new SlotTEInput(inventory, i, 8, 62 - 18 * i, tile));
            // input slot
            func_75146_a(new SlotTEInput(inventory, 4, 80, 20, tile));
            // output slots
            func_75146_a(new SlotTEInput(inventory, 5, 71, 48, tile));
            func_75146_a(new SlotTEInput(inventory, 6, 89, 48, tile));
        }
    }
}
