/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.items.itemblock;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import net.dries007.tfc.objects.blocks.BlocksTFC;
import net.dries007.tfc.objects.te.TELogPile;
import net.dries007.tfc.objects.te.TEPitKiln;
import net.dries007.tfc.util.Helpers;

public class ItemBlockTorchTFC extends ItemBlockTFC
{

    public ItemBlockTorchTFC(Block b)
    {
        super(b);
    }

    @Override
    public boolean onEntityItemUpdate(EntityItem entityItem)
    {
        BlockPos pos = entityItem.func_180425_c().func_177977_b();
        World world = entityItem.func_130014_f_();
        IBlockState state = entityItem.func_130014_f_().func_180495_p(pos);

        // noinspection ConstantConditions
        if (state.func_177230_c() == BlocksTFC.LOG_PILE || state.func_177230_c() == BlocksTFC.PIT_KILN)
        {
            int count = entityItem.getEntityData().func_74762_e("torchCount");
            if (count > 160)
            {
                if (state.func_177230_c() == BlocksTFC.LOG_PILE)
                {
                    TELogPile te = Helpers.getTE(world, pos, TELogPile.class);
                    if (te != null)
                        te.light();
                    // This happens automatically for Pit Kiln
                    if (!Blocks.field_150480_ab.func_176196_c(world, pos))
                        world.func_175656_a(pos.func_177984_a(), Blocks.field_150480_ab.func_176223_P());
                }
                else if (state.func_177230_c() == BlocksTFC.PIT_KILN)
                {
                    TEPitKiln te = Helpers.getTE(world, pos, TEPitKiln.class);
                    if (te != null)
                        te.tryLight();
                }
                entityItem.func_70106_y();
            }
            else
            {
                if (Math.random() <= 0.1)
                    world.func_175688_a(EnumParticleTypes.LAVA, entityItem.field_70165_t, entityItem.field_70163_u, entityItem.field_70161_v,
                        -0.5F + Math.random(), -0.5F + Math.random(), -0.5F + Math.random());
                entityItem.getEntityData().func_74768_a("torchCount", count + 1);
            }
        }
        return super.onEntityItemUpdate(entityItem);
    }
}
