/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.items.metal;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

import mcp.MethodsReturnNonnullByDefault;
import net.dries007.tfc.api.capability.size.Size;
import net.dries007.tfc.api.capability.size.Weight;
import net.dries007.tfc.api.types.Metal;
import net.dries007.tfc.api.util.IPlaceableItem;
import net.dries007.tfc.objects.blocks.metal.BlockAnvilTFC;

import static net.dries007.tfc.objects.blocks.metal.BlockAnvilTFC.AXIS;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public class ItemAnvil extends ItemMetal implements IPlaceableItem
{
    public ItemAnvil(Metal metal, Metal.ItemType type)
    {
        super(metal, type);
    }

    @Override
    public Size getSize(ItemStack stack)
    {
        return Size.HUGE;
    }

    @Override
    public Weight getWeight(ItemStack stack)
    {
        return Weight.HEAVY;
    }

    @Override
    public boolean canStack(ItemStack stack)
    {
        return false;
    }

    @Override
    public boolean placeItemInWorld(World world, BlockPos pos, ItemStack stack, EntityPlayer player, EnumFacing facing, Vec3d hitVec)
    {
        if (!(stack.func_77973_b() instanceof ItemAnvil))
        {
            return false;
        }
        IBlockState state = world.func_180495_p(pos.func_177972_a(facing));
        if (state.func_177230_c().func_176200_f(world, pos.func_177972_a(facing)))
        {
            if (!world.field_72995_K)
            {
                ItemAnvil anvil = (ItemAnvil) stack.func_77973_b();
                world.func_175656_a(pos.func_177972_a(facing), BlockAnvilTFC.get(anvil.metal).func_176223_P().func_177226_a(AXIS, player.func_174811_aO().func_176740_k() == EnumFacing.Axis.X));

                world.func_184133_a(null, pos.func_177972_a(facing), SoundEvents.field_187692_g, SoundCategory.BLOCKS, 1.0F, 1.0F);
            }
            return true;
        }
        return false;
    }
}
